/// <reference types="node" />
import { PathLike, Stats } from 'fs';
export interface IModule {
    _extensions: Map<string, () => void>;
    _originalFindPath(request: string, searchPaths: Array<string>, isMain: boolean): any;
    _alternateFindPath(request: string, searchPaths: Array<string>, isMain: boolean): any;
    _findPath(request: string, searchPaths: Array<string>, isMain: boolean): any;
    _pathCache: any;
    _fallback: boolean;
}
export interface IReadOnlySynchronousFileSystem {
    readFileSync(path: PathLike | number, options?: {
        encoding?: string | null;
        flag?: string;
    } | string | null): string | Buffer;
    realpathSync(path: PathLike, options?: {
        encoding?: string | null;
    } | string | null): string;
    statSync(path: PathLike): Stats;
}
export declare function patchModuleLoader(volume: IReadOnlySynchronousFileSystem, enablePathNormalization?: boolean, enableFallback?: boolean, Module?: IModule): () => void;
